# -*- coding: utf-8 -*-
import platform
from setuphelpers import *

uninstallkey = []


def install():

    isapt = True
    try:
        run('apt-get --version')
    except:
        isapt = False

    version_soft = control.version.split('-')[0]

    if isapt :
        run("tar -xf LibreOffice_%s_Linux_x86-64_deb_helppack_%s.tar.gz" % (version_soft,control.locale))
        run('dpkg -i */DEBS/*.deb')
    else:
        run("tar -xf LibreOffice_%s_Linux_x86-64_rpm_helppack_%s.tar.gz" % (version_soft,control.locale))
        run('yum install RPMS/*.rpm -y')

def uninstall():
    sversion = control.version.split('.')[0] + '.' + control.version.split('.')[1]
    run_notfatal('LANG=C DEBIAN_FRONTEND=noninteractive apt-get remove -y libobasis%s-%s-help' % (sversion,control.locale))



def update_package():
      # Update transition from BeautifulSoup 3 to 4
    try:
        import bs4 as BeautifulSoup
    except:
        import BeautifulSoup
    import requests,re
    from waptpackage import PackageEntry

    # Get Proxy informations from WAPT settings
    proxies = {}
    if isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxies = {'http':proxywapt,'https':proxywapt}

    verify=True
    pe = PackageEntry()
    pe.load_control_from_wapt(os.getcwd())
    current_version = pe['version'].split('-',1)[0]
    verify=True

    url = "https://www.libreoffice.org/download/download"

    # Get latest version number from official website
    page = requests.get(url,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64)'},verify=verify,proxies=proxies).text
    bs = BeautifulSoup.BeautifulSoup(page)
    bs_raw_string = str(bs.findAll('span',{'class':'dl_version_number'}))
    version1 = bs_raw_string
    version0 = version1.split('>',3)[3]
    version = version0.split('<',1)[0]
    print('Latest LibreOffice stable version is: '+ version)

    #https://download.documentfoundation.org/libreoffice/stable/
    #https://par.mirror.cyberbits.eu/tdf/libreoffice/stable/

    urldl = "http://download.documentfoundation.org/libreoffice/stable/%s/deb/x86_64/LibreOffice_%s_Linux_x86-64_deb_helppack_%s.tar.gz" % (version,version,control.locale)
    print('Download url is: ' + urldl)
    filelatest = "LibreOffice_%s_Linux_x86-64_deb_helppack_%s.tar.gz" % (version,control.locale)

    # Deleting outdated binaries
    for fileactual in glob.glob('*deb*.tar.gz'):
        if fileactual != filelatest :
            print(fileactual + ' Deleted')
            remove_file(fileactual)

    # Downloading latest binaires
    if not isfile(filelatest):
        print('Download ' + urldl)
        wget(urldl,filelatest,proxies=proxies)

        control.version = version + '-14'
        control.save_control_to_wapt()
        print ('Update package done. You can now build-upload your package')
    else:
        print ('This package is already up-to-date')



    urldl = "http://download.documentfoundation.org/libreoffice/stable/%s/rpm/x86_64/LibreOffice_%s_Linux_x86-64_rpm_helppack_%s.tar.gz" % (version,version,control.locale)
    print('Download url is: ' + urldl)
    filelatest ="LibreOffice_%s_Linux_x86-64_rpm_helppack_%s.tar.gz" % (version,control.locale)

    # Deleting outdated binaries
    for fileactual in glob.glob('*rpm*.tar.gz'):
        if fileactual != filelatest :
            print(fileactual + ' Deleted')
            remove_file(fileactual)

    # Downloading latest binaires
    if not isfile(filelatest):
        print('Download ' + urldl)
        wget(urldl,filelatest,proxies=proxies)
        print ('Update package done. You can now build-upload your package')
    else:
        print ('This package is already up-to-date')